#include <bits/stdc++.h>
using namespace std;

int Resi(int N, int K, int* L, char** A, char* S){
//    if(K == 2){
//        string tmp;
//        for(int i = 0; i < (1<<18); ++i){
//            tmp = "";
//            for(int j = 0; j < 18; ++j){
//                if(i & (1<<j)){
//                    tmp.push_back('a');
//                } else {
//                    tmp.push_back('b');
//                }
//            }
//
//        }return 1;
//    } else if (N == 2){
    if(N == 2){
        string a, b;
        a = "";
        b = "";
        for(int i = 1; i <= 2; ++i){
            for(int j = 1; j <= L[i]; ++j){
                if(i == 1){
                    a += A[i][j];
                } else {
                    b+=A[i][j];
                }
                if((A[i][j]-'a' + 1) > K){
                    return -1;
                }
            }
        }
        if(a.length() > b.length()){
            swap(a, b);
        }
        int aS = 0;
        for(int i = 0; i < b.length()-a.length()+1; ++i){
            if(b.substr(i, a.length()) == a){
                aS++;
            }
        }
        if(aS >= 2){
            return -1;
        }
        if(aS == 1){
            copy(b.begin(), b.end(), S+1);
            return b.length();
        }
        int pref = a.length(), suf = -1;
        for(int i = 0; i < a.length(); ++i){
            if(a.substr(i) == b.substr(0, a.length()-i)){
                pref = i;
                break;
            }
        }
        for(int i = a.length(); i >= 1; --i){
            if(a.substr(0, i) == b.substr(b.length()-i)){
                suf = i-1;
                break;
            }
        }
        string res1 = "", res2 = b;
        for(int i = 0; i < pref; ++i){
            res1 += a[i];
        }
        res1 += b;
        for(int i = suf+1; i < a.length(); ++i){
            res2 += a[i];
        }
        cout << res1 << ' ' << res2 << '\n';
        if(res1.length() < res2.length()){
            copy(res1.begin(), res1.end(), S+1);
            return res1.length();
        } else {
            copy(res2.begin(), res2.end(), S+1);
            return res2.length();
        }
    }
};